# Copyright 2008, Matt666
#reptxt
#Replace a used existant texture with another existant texture. You have to select a textured face (the replaced texture), and choose a replacing texture in the texture window.
#Plugins folder "Remplacer texture"
#Sorry for the translation, I'm French !!
#
#
#Remplacer une texture existante utilise par une autre. I faut slectionner un face avec la texture  remplacer, et choisir la texture remplaante dans la fentre matires
#Menu Plugins, "remplacer texture"

def reptxt
	model = Sketchup.active_model
	ss = model.selection
	model.start_operation "Remplacer textures"
	if model.materials.current !=nil
		active_material = model.materials.current.name
		puts "Texture active = " + active_material
		if ss.empty?
			UI.messagebox("Aucune selection.")
			return nil
		else
			ent = ss[0]
			if ent.typename == "Face"
				puts "\nL'entit slectionne est de type Face."
				if ent.material !=nil
					anctxt = ent.material
				else
					anctxt = ent.back_material
				end
				#if ent.material !=nil
					process_reptxt model.active_entities, ent.material, active_material
					model.commit_operation
				#end
			else
				UI.messagebox("\nL'entit slectionne n'est pas de type Face (" + ss[0].typename + ").")
			end
		end
	else
		UI.messagebox("Aucune texture active.")
		return nil
	end
end

def process_reptxt(entities, anctxt, newtxt)
	entities.each do |entity| 
		case entity.typename
		when 'Group'
			process_reptxt entity.entities, anctxt, newtxt
		when 'ComponentInstance'
			entity.material = newtxt if entity.material == anctxt
			edef = entity.definition
			process_reptxt edef.entities, anctxt, newtxt
		when 'Face'
			entity.material = newtxt if entity.material == anctxt
			entity.back_material = newtxt if entity.back_material == anctxt
		end
	end
end

if( not file_loaded?("reptxt.rb") )
	UI.menu("Plugins").add_item("Remplacer texture") { reptxt }
end
file_loaded("reptxt.rb")